
#ifndef _Concept_h_
#define _Concept_h_

#include <list>
#include "String.h"

class StaticConcept;
class StaticDiagram;

class Concept
{
 public:

  Concept(const String& name = "DefaultConcept") : mName(name),mStaticDiagram(0) {}
  const String& getName() const { return mName; }
  void addStaticConcept(StaticConcept* sc) { mStaticConcepts.push_back(sc); }
  void addPort(Concept* port) { mPorts.push_back(port); }
  bool portExists(Concept* port);
  void setStaticDiagram(StaticDiagram* sd) { mStaticDiagram = sd; }

  const list<StaticConcept*>& getStaticConcepts() const { return mStaticConcepts;}
  StaticDiagram* getStaticDiagram() { return mStaticDiagram; }
  const list<Concept*>& getPorts() const { return mPorts; }
 private:
  String mName;
  StaticDiagram* mStaticDiagram;
  list<StaticConcept*> mStaticConcepts;
  list<Concept*> mPorts;
};

#endif
