
#include "ConceptMap.h"
#include <map>
#include "String.h"
#include <iostream.h>
#include <function.h>
#include <algo.h>

ConceptMap globalConcepts;

int printConceptName(ConceptMap::value_type elem)
{
  cout << elem.first << endl;
  return 0;
}

void printGlobalConcepts()
{
  cout << "Concepts List:" << endl;
  for_each(globalConcepts.begin(),globalConcepts.end(),ptr_fun(printConceptName));
  cout << "-----------" << endl;
}

Concept* findGlobalConcept(const String& name)
{
  ConceptMap::iterator i(globalConcepts.find(name));
  if (i == globalConcepts.end())
    return 0;
  else return (*i).second;

}

Concept* insertGlobalConcept(Concept* concept)
{
  if (!concept) return 0;
  ConceptMap::iterator i(globalConcepts.find(concept->getName()));

  if (i == globalConcepts.end()) 
    {
      globalConcepts.insert(ConceptMap::value_type(concept->getName(),concept));
    }
  else concept = (*i).second;
  
  return concept;
}
