
#include "ErrorCodes.h"
#include "String.h"

const String&
getErrorString(ErrorCode error)
{
  static String ConnectorDoesNotExists = "Connector does not exists";
  static String ConceptDoesNotExists = "Concept does not exists";
  static String ConnectionExists = "Connection exists";
  static String ConnectorNotDefined = "Connector not defined";
  static String PortDoesNotExists = "Port does not exists";
  static String PortIsOccupied = "Port is occupied";
  static String PortDefinitionNotAllowed = "Port definition not allowed";
  static String UnknownError = "Unknown Error";
  switch (error)
    {
    case eConnectorDoesNotExists : return ConnectorDoesNotExists;
    case eConceptDoesNotExists : return ConceptDoesNotExists;
    case eConnectionExists: return ConnectionExists;
    case eConnectorNotDefined: return ConnectorNotDefined;
    case ePortDoesNotExists: return PortDoesNotExists;
    case ePortIsOccupied : return PortIsOccupied;
    case ePortDefinitionNotAllowed : return PortDefinitionNotAllowed;
default: return UnknownError;
    };
}
