
#ifndef _StaticConcept_h_
#define _StaticConcept_h_

#include <list>
#include "Concept.h"
#include "ErrorCodes.h"

class StaticConcept
{
 public:
  struct Connection
  {
    Connection(StaticConcept& con,Concept& p) : connector(con),port(p) {}
    StaticConcept& connector;
    Concept& port;
  };
  StaticConcept(Concept& concept);
  const String& getName() const { mConcept.getName(); }
  ErrorCode connect(StaticConcept& connector,const String& port);
  ErrorCode definePort(StaticConcept& concept);
  ErrorCode connectPort(Concept& portConcept);
  ErrorCode releasePort(Concept& portConcept);

  const Concept& getConcept() const { return mConcept; }
  const list<Connection*>& getConnections() const { return mConnections; }
 private:
  bool sameConnection(Connection* con1,Connection* con2);
  
  Concept& mConcept;
  list<Connection*> mConnections;
  list<Concept*> mOccupiedPorts;
};

#endif
