
#include "StaticConceptConsoleView.h"
#include <iostream.h>
#include "StaticConcept.h"
#include <function.h>
#include <algo.h>

void StaticConceptConsoleView::show()
{
  int menuSelection;
  do
    {
      cout << "StaticConcept menu" << endl;
      cout << "0. exit" << endl;
      cout << "1. print connections" << endl;
      cout << "2. print ports" << endl;
      cin >> menuSelection;
 
      switch (menuSelection)
	{
	case 0: break;
	case 1: printConnections(); break;
	case 2: printPorts(); break;
	}
    } while (menuSelection != 0);
}

int printConnection(StaticConcept::Connection* elem)
{
  if (!elem) return 0;
  cout << "Connector: " << elem->connector.getName() << endl;
  cout << "Port: " << elem->port.getName() << endl;
}

void
StaticConceptConsoleView::printConnections()
{
  if (!mModel) return;
  const list<StaticConcept::Connection*>& concepts(mModel->getConnections());
  
  cout << "Connections:" << endl;
  for_each(concepts.begin(),concepts.end(),ptr_fun(printConnection));
  cout << "------------" << endl;  
}

int printConcept(Concept* elem)
{
  if (!elem) return 0;
  cout << "Concept: " << elem->getName() << endl;
}

void
StaticConceptConsoleView::printPorts()
{
  if (!mModel) return;
  const list<Concept*>& ports(mModel->getConcept().getPorts());
  
  cout << "Ports:" << endl;
  for_each(ports.begin(),ports.end(),ptr_fun(printConcept));
  cout << "------------" << endl;  
}

