
#include "StaticDiagram.h"
#include "ConceptMap.h"

StaticDiagram::addConcept(const String& name)
{
  mConcepts.push_back(new StaticConcept(*addGlobalConcept(name,(Concept*)0)));
}

StaticConcept* StaticDiagram::getStaticConcept(const String& name)
{
  for (list<StaticConcept*>::iterator i = mConcepts.begin(); 
       i != mConcepts.end();
       ++i)
    if ((*i)->getName() == name) return *i;
  return 0;
}

ErrorCode StaticDiagram::connect(const String& concept,
			    const String& connector,
			    const String& port)
{
  StaticConcept* sConcept = getStaticConcept(concept);
  if (!sConcept) return eConceptDoesNotExists;
  StaticConcept* sConnector = getStaticConcept(connector);
  if (!sConnector) return eConnectorDoesNotExists;

  return sConcept->connect(*sConnector,port);
}

ErrorCode StaticDiagram::definePort(const String& connector,const String& port)
{
  StaticConcept* sConnector = getStaticConcept(connector);
  if (!sConnector) return eConnectorDoesNotExists;
  StaticConcept* sPort = getStaticConcept(port);
  if (!sPort) return ePortDoesNotExists;

  sConnector->definePort(*sPort);
}
