
#ifndef _StaticDiagram_h_
#define _StaticDiagram_h_

#include <list>
#include "StaticConcept.h"
#include "String.h"
#include "ErrorCodes.h"

class StaticDiagram 
{
 public:
  StaticDiagram(Concept& concept) : mConcept(concept)
    { concept.setStaticDiagram(this); }
  addConcept(const String& name);
  const list<StaticConcept*>& getConcepts() { return mConcepts; }
  StaticConcept* getStaticConcept(const String& name);
  ErrorCode connect(const String& concept,
		    const String& connector,
		    const String& port);
  ErrorCode definePort(const String& connector,const String& port);
 private:
  Concept& mConcept;
  list<StaticConcept*> mConcepts;
};

#endif
