
#include "StaticDiagramConsoleView.h"
#include "StaticConceptConsoleView.h"
#include <iostream.h>
#include <String.h>
#include <function.h>
#include <algo.h>
#include "StaticDiagram.h"
#include "ConceptMap.h"
#include "ErrorCodes.h"

void StaticDiagramConsoleView::show()
{
  int menuSelection;
  do
    {
      cout << "StaticDiagram menu" << endl;
      cout << "0. exit" << endl;
      cout << "1. new concept" << endl;
      cout << "2. global concepts list" << endl;
      cout << "3. local static concepts" << endl;
      cout << "4. show static concept" << endl;
      cout << "5. connect concepts" << endl;
      cout << "6. define port" << endl;
      cin >> menuSelection;
 
      switch (menuSelection)
	{
	case 0: break;
	case 1:
	  {
	    cout << "insert Concept name: ";
	    String name;
	    cin >> name;
	    if (mModel) mModel->addConcept(name);
	    break;
	  }
	case 2:
	  printGlobalConcepts();
	  break;
	case 3:
	  printStaticConcepts();
	  break;
	case 4:
	  {
	    cout << "insert Concept name: ";
	    String concept;
	    cin >> concept;
	    StaticConcept* sc = mModel->getStaticConcept(concept);
	    if (!sc) 
	      {
		cout << "no such concept" << endl;
		break;
	      }
	    StaticConceptConsoleView scv(sc);
	    scv.show();
	    break;
	  }
	case 5:
	  {
	    cout << "insert Concept name: ";
	    String concept;
	    cin >> concept;
	    cout << "insert Connector name: ";
	    String connector;
	    cin >> connector;
	    cout << "insert Port name: ";
	    String port;
	    cin >> port;
	    if (mModel) 
	      { 
		ErrorCode result = mModel->connect(concept,connector,port);
		if (result != eSuccess)
		  cout << getErrorString(result) << endl;
	      }
	    break;
	  }
	case 6:
	  {
	    cout << "insert Connector name: ";
	    String connector;
	    cin >> connector;
	    cout << "insert Port name: ";
	    String port;
	    cin >> port;
	    if (mModel) 
	      { 
		ErrorCode result = mModel->definePort(connector,port);
		if (result != eSuccess)
		  cout << getErrorString(result) << endl;
	      }
	    break;
	  }
	}
    } while (menuSelection != 0);
}

int printStaticConceptName(StaticConcept* elem)
{
  cout << elem->getName() << endl;
}

void StaticDiagramConsoleView::printStaticConcepts()
{
  const list<StaticConcept*>& concepts(mModel->getConcepts());

  cout << "Static Concepts:" << endl;
  for_each(concepts.begin(),concepts.end(),ptr_fun(printStaticConceptName));
  cout << "----------------" << endl;
}
